﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateFrame = CreateFrame("frame","DCoordsUpdateFrame");
DCoordsUpdateFrame:RegisterEvent("ADDON_LOADED");
DCoordsUpdateFrame:RegisterEvent("VARIABLES_LOADED");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
DCoordsUpdateFrame:RegisterEvent("ZONE_CHANGED");
DCoordsUpdateFrame:RegisterEvent("PLAYER_LOGOUT");	
DCoordsUpdateFrame:SetScript("OnUpdate", function(self) DCoordsUpdateHandler() end);

DCoordsUpdateFrame:SetScript("OnEvent", function(self,event,addonName)
	if (event == "ADDON_LOADED") then
		if (addonName == "DCoords") then
			log("DCoords v"..DCoordsVersion.." ADDON_LOADED!");
			DCVGlobal["DCLoaded"] = true;
		end
	elseif (event == "VARIABLES_LOADED") then
		log("DCoords v"..DCoordsVersion.." VARIABLES_LOADED!");
		DCVGlobal["DCVarsLoaded"] = true;
		DCoordsInit();
	else
		--log("DCoords: WARNING: Unhandled event: [" .. event .. "]");
	end
end);
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function showOptions()
		playClick();
		InterfaceOptionsFrame_OpenToCategory(DCVGlobal["DCOptions"].Main.name); -- will open interface menu
		InterfaceOptionsFrame_OpenToCategory(DCVGlobal["DCOptions"].Other.name); -- will  expand of sub options of DCoords
		InterfaceOptionsFrame_OpenToCategory(DCVGlobal["DCOptions"].Main.name); -- will select main DCoords entry
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initState()
	log("initState()");
	
	mainBarSetVisibility();
	mainBarSetFrameAlignment();
	mainBarSetBackground();
	mainBarSetFont();
	updateMinimap();
	
	worldMapSetVisibility();
	worldMapSetPosition();
	worldMapSetFont();
	
	initObjectiveTracker();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsSlashCommandHandler(cmd)
	log("DCoordsSlashCommandHandler(): " .. cmd);
	
	if (cmd == nil or cmd == "" or string.find(cmd, "help") ~= nil) then
		toChat(" ");
		toChat("DCoords v" .. DCoordsVersion .. " slash commands:");
		toChat("  /DC menu - show menu");
		toChat("  /DC show  - show coordinates");
		toChat("  /DC hide - hide coordinates");
		toChat("  /DC reset - reset position and settings");
		return;
	end
	
	strSearchResult = string.find(cmd,"reset");
	if (strSearchResult ~= nil) then
		toChat("DCoords attempting to reset positions...");
		reset();
		return;
	end
	
	if (cmd == "menu") then
		showOptions();
		return;
	end
	
	if (cmd == "show menu") then
		showOptions();
		return;
	end
		
	if (cmd == "show") then
		DCoordsVDB["MainBar"].visible = true;
		mainBarSetVisibility();
		return;
	end
	
	if (cmd == "hide") then
		DCoordsVDB["MainBar"].visible = false;
		mainBarSetVisibility();
		return;
	end


	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsInit()
	log("DCoordsInit()");
	
	-- Ensure vars are ok
	--DCoordsVDB = nil;

	-- One time calls
	SetMapToCurrentZone(); -- Works anyway but could be another addon doing that
	
	-- Init
	initOptions();
	initMainBar();
	initWorldMapCoordinates();
	
	-- State init
	initState();
	
	
	-- Setup slash commands
	SlashCmdList["DCoordsCOMMAND"] = DCoordsSlashCommandHandler;
	SLASH_DCoordsCOMMAND1 = "/dc";
	
	-- Message
	toChat(" ");
	toChat("DCoords v"..DCoordsVersion);
	toChat("DCoords: To view DCoords settings right click coordinates bar.");
	toChat("DCoords: To drag DCoords hold SHIFT + LEFT CLICK DRAG.");
	toChat("DCoords: To reset DCoords type /DC reset.");
	
	-- DCoords is ready
	DCVGlobal["DCReady"] = true;
	
	--showOptions();

	
	--[[
	local a = MinimapZoneTextButton:GetChildren();
	local b = MinimapCluster:GetChildren();
	
	
	
	
	for k,v in pairs(b) do
		--print(v:GetName());
	end
	
	
	--local kids = { Minimap:GetChildren() };
	local kids = { MinimapCluster:GetChildren() };
	
	local function myTest(frame)
		frame:Hide();
		return frame:GetName();
	end
	
	for key,child in ipairs(kids) do
		local retOK, ret1 = pcall(myTest,child);
		print(ret1);
		
	end
	--]]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




function logTable(tbl)
	for k, v in pairs( tbl ) do
		--print(v);
		print( type(v) .. ": " .. tostring(v));
		if (type(v) == "table") then
			logTable(v)
		end
	end
end

function logTable2(tbl)
	for k, v in pairs( tbl ) do
		if (type(v) == "table") then
			print(v);
		else
			print(v)
		end
	end
end




--[[
-- EXPERIEMENTAL REFERENCES
local oo = _G["MinimapZoneTextButton"];
oo:Hide();	
	
	
--]]




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function reset()
	log("reset()");
	
	log("################################");
	log("alignmentIndex = " .. DCoordsVDB["MainBar"].alignmentIndex);
	initVars();
	log("alignmentIndex = " .. DCoordsVDB["MainBar"].alignmentIndex);
	log("################################");
	
	
	PlaySound("QUESTADDED");
    ReloadUI();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #