﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- Var ini
local t = 0;
local tLim = 0;
local strange = 0;
local playerCoordinates = "";

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateHandler = function()
	--toChat( GetMouseFocus():GetName() );
	--print( GetMouseFocus():GetName() );

	-- DCoords ready?
	if ( DCVGlobal["DCReady"] == false ) then
		return;
	end
	
	
	-- Combat flag
	DCVGlobal["IsInCombat"] = UnitAffectingCombat('player');
	if (not DCVGlobal["IsInCombat"]) then
		DCVGlobal["IsInCombat"] = false;
	end
	
	
	-- Handle timing
	t = t+1;
	if (t <= tLim) then
		return;
	else
		if (DCVGlobal["IsInCombat"] == false) then
			tLim = t + DCoordsVDB["updateDelay"];
		else
			tLim = t + DCoordsVDB["updateDelayInCombat"];
		end
	end
	
	
	-- Always get coordinates
	getPlayerCoordinates();
	
	-- Update MainBar
	if ( DCoordsVDB["MainBar"].visible == true ) then
		updateMainBar();
	end
	
	-- Update WorldMap
	if ( DCoordsVDB["WorldMap"].visible == true and WorldMapFrame:IsVisible() == true ) then
		updateWorldMap();
	end
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




local precision = nil;
local px = 0;
local py = 0;
local zone = "";
local subZone = "";
local zoneText = "";
local playerCoordinats = "";



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getPlayerCoordinates()
	px, py = GetPlayerMapPosition("player");
	
	precision = "%.".. DCoordsVDB["MainBar"].decimalPrecision .."f";
	px = string.format(precision, (px*100));
	py = string.format(precision, (py*100));
	
	playerCoordinats = px  .. " : " .. py;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateMainBar()
	
	-- Prevent update if MainBar is not visible
	if ( DCVGlobal["DCMainBar"]:IsVisible() == false) then
		return;
	end

	if (DCoordsVDB["MainBar"].showZone == true) then
		zone = GetZoneText();
	else
		zone = "";
	end
	
	if (DCoordsVDB["MainBar"].showSubZone == true) then
		subZone = GetSubZoneText();
	else
		subZone = "";
	end
	

	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		if (zone ~= "") and (subZone ~= "") then
			location = zone .. " - " .. subZone;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone;
		elseif (zone ~= "") and (subZone == "") then
			location = zone;
		else
			location = "Darcey@AllForTheCode.co.uk";
		end
	else
		if (zone == "") and (subZone == "") then
			location = px .. " - " .. py;
		elseif (zone ~= "") and (subZone == "") then
			location = zone .. " - " .. playerCoordinats;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone .. " - " .. playerCoordinats;
		elseif (zone ~= "") and (subZone ~= "") then
			if (zone == subZone) then
				location = zone .. " - " .. playerCoordinats;
			else
				location = zone .. " - " .. subZone .. " - " .. playerCoordinats;
			end
		else
			location = "      ";
		end
	end
	
	location = "  " .. location .. "  ";
	
	--DCVGlobal["DCMainBarText"]:SetText(" " .. t .. " " .. location);
	DCVGlobal["DCMainBarText"]:SetText(location);
	--DCVGlobal["DCMainBarText"]:SetJustifyH("LEFT");
	
	local frameW = DCVGlobal["DCMainBarText"]:GetStringWidth() + DCoordsVDB["MainBar"].paddingLeftRight;
	local frameH = DCVGlobal["DCMainBarText"]:GetStringHeight() + DCoordsVDB["MainBar"].paddingTopBottom;
	DCVGlobal["DCMainBar"]:SetWidth(frameW);
	DCVGlobal["DCMainBar"]:SetHeight(frameH);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateWorldMap()
	--DCVGlobal["DCWorldMapText"]:SetText(" " .. t .. " " .. location);
	
	-- World map calc
	local mapscale = WorldMapDetailFrame:GetEffectiveScale();
	local cursorX, cursorY = GetCursorPosition();
	cursorX = cursorX / mapscale;
	cursorY = cursorY / mapscale;
	local width = WorldMapDetailFrame:GetWidth();
	local height = WorldMapDetailFrame:GetHeight();
	local left = WorldMapDetailFrame:GetLeft();
	local top = WorldMapDetailFrame:GetTop();
	
	cursorX = (cursorX - left) / width * 100;
	cursorY = (top - cursorY) / height * 100;
	
	local cx, cy;
	if (DCoords_MainFrameDecimalPrecision==3) then
		cx = format("%.3f",cursorX);
		cy = format("%.3f",cursorY);
	elseif (DCoords_MainFrameDecimalPrecision==2) then
		cx = format("%.2f",cursorX);
		cy = format("%.2f",cursorY);
	elseif (DCoords_MainFrameDecimalPrecision==1) then
		cx = format("%.1f",cursorX);
		cy = format("%.1f",cursorY);
	else
		cx = floor(cursorX);
		cy = floor(cursorY);
	end

	
	--DCVGlobal["DCWorldMapText"]:SetText("You: [" .. playerX .. " - " .. playerY .. "]     " .. DCoordsMapTextLabel);
	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		DCVGlobal["DCWorldMapText"]:SetText("Cursor " .. cx .. " : " .. cy);
	else 
		DCVGlobal["DCWorldMapText"]:SetText("You " .. px .. " : " .. py .. "     Cursor " .. cx .. " : " .. cy);
		--log(DCoordsMapTextLabel);
		--log(mouseIsOverMap);
		--log( GetMouseFocus():GetName() );
	end	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #