--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

local frame;

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMainbar()
	DCVGlobal["DCOptions"].Mainbar = CreateFrame( "Frame", "DCoordsOptionsMainPage", UIParent );
	frame = DCVGlobal["DCOptions"].Mainbar;
	frame.name = "Coordinates bar";
	frame.parent = DCVGlobal["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Coordinates bar");
	
	
	setupPageMainbarLeft();
	setupPageMainbarRight();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMainbarLeft()
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	
	
	--DCoordsVDB["MainBar"].visible
	local function cbVisibleClickHandler(ticked)
		DCoordsVDB["MainBar"].visible = ticked;
		mainBarSetVisibility();
	end
	createCheckbox("MainBarVisible",frame,"Coordinates bar visible",DCoordsVDB["MainBar"].visible,px,py,cbVisibleClickHandler);
	py = py - inc;
	
	
	
	--DCoordsVDB["MainBar"].showZone
	local function cbShowZoneClickHandler(ticked)
		DCoordsVDB["MainBar"].showZone = ticked;
		mainBarSetVisibility();
	end
	createCheckbox("cbShowZone",frame,"Show zone",DCoordsVDB["MainBar"].showZone,px,py,cbShowZoneClickHandler);
	py = py - inc;
	
	
	--DCoordsVDB["MainBar"].showSubZone
	local function cbShowSubZoneClickHandler(ticked)
		DCoordsVDB["MainBar"].showSubZone = ticked;
		mainBarSetVisibility();
	end
	createCheckbox("cbShowSubZone",frame,"Show sub zone",DCoordsVDB["MainBar"].showSubZone,px,py,cbShowSubZoneClickHandler);
	py = py - inc;
	
	
	
	
	
	--DCoordsVDB["MainBar"].alignmentIndex
	local function alignmentIndexChangeHandler(selectedIndex)
		DCoordsVDB["MainBar"].alignmentIndex = selectedIndex;
		DCoordsVDB["MainBar"].x = 0;
    	DCoordsVDB["MainBar"].y = 0;
		mainBarSetFrameAlignment();
	end
	local addonAlignmentLabels = {
		"Align addon to the TOP LEFT",
		"Align addon to the TOP",
		"Align addon to the TOP RIGHT",
		"Align addon to the LEFT",
		"Align addon to the CENTER",
		"Align addon to the RIGHT",
		"Align addon to the BOTTOM LEFT",
		"Align addon to the BOTTOM",
		"Align addon to the BOTTOM RIGHT"
	};
	createDropDown("alignmentIndex",frame,dropDownWidth,addonAlignmentLabels,DCoordsVDB["MainBar"].alignmentIndex,px,py,alignmentIndexChangeHandler)
	py = py - 19;
	
	
		--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Addon alignment changes direction of growth." .. "\n\n";
	createLabel("DCAlignInfo1",frame,msg,14,1,0.5,0.5,1,"LEFT",27,py);
	py = py - 28;

	
	--[[
	--DCoordsVDB["MainBar"].fontAlignmentIndex
	local function fontAlignmentIndexChangeHandler(selectedIndex)
		DCoordsVDB["MainBar"].fontAlignmentIndex = selectedIndex;
		mainBarSetFont();
	end
	local textAlignmentLabels = {
		"Align text TOP LEFT",
		"Align text TOP",
		"Align text TOP RIGHT",
		"Align text LEFT",
		"Align text CENTER",
		"Align text RIGHT",
		"Align text BOTTOM LEFT",
		"Align text BOTTOM",
		"Align text BOTTOM RIGHT"
	};
	createDropDown("fontAlignmentIndex",frame,dropDownWidth,textAlignmentLabels,DCoordsVDB["MainBar"].fontAlignmentIndex,px,py,fontAlignmentIndexChangeHandler)
	py = py - 30;
	
	
	
	--DCoordsVDB["MainBar"].fontSelectedJustificationIndex
	local function fontJustificationChangeHandler(selectedIndex)
		DCoordsVDB["MainBar"].fontSelectedJustificationIndex = selectedIndex;
		mainBarSetFont();
	end
	
	createDropDown("fontJustificationDropDown",frame,dropDownWidth,DCVGlobal["JustificationOptions"],DCoordsVDB["MainBar"].fontSelectedJustificationIndex,px,py,fontJustificationChangeHandler)
	py = py - 30;
	--]]
	
	
	
	--DCoordsVDB["MainBar"].fontSelectedIndex
	local function fontSelectedIndexChangeHandler(selectedIndex)
		DCoordsVDB["MainBar"].fontSelectedIndex = selectedIndex;
		mainBarSetFont();
	end
	local fontLabels = {}
	for i = 1, 15, 1 do
		fontLabels[i] = "Coordinates bar use Font no' " .. tostring(i);
	end
	createDropDown("fontSelectedIndex",frame,dropDownWidth,fontLabels,DCoordsVDB["MainBar"].fontSelectedIndex,px,py,fontSelectedIndexChangeHandler)
	py = py - 50;
	
	
	
	
	--DCoordsVDB["MainBar"].fontSize
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontSizeChangeHandler(v)
		DCoordsVDB["MainBar"].fontSize = v;
		mainBarSetFont();
	end
	createSlider("fontSize",frame,5,50,0.1,"Font size",DCoordsVDB["MainBar"].fontSize,sliderWidth,1,px,py,fontSizeChangeHandler)
	py = py - 40;
	
	
	
	--DCoordsVDB["MainBar"].fontOffsetX
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontOffsetXChangeHandler(v)
		DCoordsVDB["MainBar"].fontOffsetX = v;
		mainBarSetFont();
	end
	createSlider("fontOffsetX",frame,-10,10,0.1,"Font offset X",DCoordsVDB["MainBar"].fontOffsetX,sliderWidth,1,px,py,fontOffsetXChangeHandler)
	py = py - 40;
	
	
	
	--DCoordsVDB["MainBar"].fontOffsetY
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontOffsetYChangeHandler(v)
		DCoordsVDB["MainBar"].fontOffsetY = v;
		mainBarSetFont();
	end
	createSlider("fontOffsetY",frame,-10,10,0.1,"Font offset Y",DCoordsVDB["MainBar"].fontOffsetY,sliderWidth,1,px,py,fontOffsetYChangeHandler)
	py = py - 70;
	
	
	
	
	
	--DCoordsVDB["MainBar"].fontR
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontRChangeHandler(v)
		DCoordsVDB["MainBar"].fontR = v;
		mainBarSetFont();
	end
	createSlider("fontR",frame,0,1,0.1,"Font Red (RGB)",DCoordsVDB["MainBar"].fontR,sliderWidth,1,px,py,fontRChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].fontG
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontGChangeHandler(v)
		DCoordsVDB["MainBar"].fontG = v;
		mainBarSetFont();
	end
	createSlider("fontG",frame,0,1,0.1,"Font Green (RGB)",DCoordsVDB["MainBar"].fontG,sliderWidth,1,px,py,fontGChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].fontB
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontBChangeHandler(v)
		DCoordsVDB["MainBar"].fontB = v;
		mainBarSetFont();
	end
	createSlider("fontB",frame,0,1,0.1,"Font Blue (RGB)",DCoordsVDB["MainBar"].fontB,sliderWidth,1,px,py,fontBChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].fontA
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function fontAChangeHandler(v)
		DCoordsVDB["MainBar"].fontA = v;
		mainBarSetFont();
	end
	createSlider("fontA",frame,0,1,0.1,"Font Alpha",DCoordsVDB["MainBar"].fontA,sliderWidth,1,px,py,fontAChangeHandler)
	py = py - 40;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMainbarRight()
	-- Vars
	local px = 350;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	
	--DCoordsVDB["MainBar"].bgVisible
	local function mainBarShowBackgroundClickHandler(ticked)
		DCoordsVDB["MainBar"].bgVisible = ticked;
		mainBarSetBackground();
	end
	createCheckbox("MainBarShowBackground",frame,"Show background",DCoordsVDB["MainBar"].bgVisible,px,py,mainBarShowBackgroundClickHandler);
	py = py - inc;
	
	
	
	--DCoordsVDB["MainBar"].bgSelectedIndex
	local function mainBarBackgroundDropDownChangeHandler(selectedIndex)
		log("mainBarBackgroundDropDownChangeHandler(selectedIndex)");
		DCoordsVDB["MainBar"].bgSelectedIndex = selectedIndex;
		mainBarSetBackground();
	end
	local labels = {
		"Classic",
		"Box"
	};
	createDropDown("bgSelectedIndex",frame,dropDownWidth,labels,DCoordsVDB["MainBar"].bgSelectedIndex,px,py,mainBarBackgroundDropDownChangeHandler)
	py = py - 30;
	
	
	
	--DCoordsVDB["MainBar"].paddingLeftRight
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function paddingLeftRightSlideChangeHandler(v)
		DCoordsVDB["MainBar"].paddingLeftRight = v;
	end
	createSlider("paddingLeftRight",frame,0,100,0.1,"Padding Left and/or Right",DCoordsVDB["MainBar"].paddingLeftRight,sliderWidth,1,px,py,paddingLeftRightSlideChangeHandler)
	py = py - 40;
	
	
	
	--DCoordsVDB["MainBar"].paddingTopBottom
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function paddingTopBtmSlideChangeHandler(v)
		DCoordsVDB["MainBar"].paddingTopBottom = v;
	end
	createSlider("paddingTopBtm",frame,0,100,0.1,"Padding Top and/or Bottom",DCoordsVDB["MainBar"].paddingTopBottom,sliderWidth,1,px,py,paddingTopBtmSlideChangeHandler)
	py = py - 70;
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	--DCoordsVDB["MainBar"].bgR
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgRChangeHandler(v)
		DCoordsVDB["MainBar"].bgR = v;
		updateBoxBgColor();
	end
	createSlider("bgRChangeHandler",frame,0,1,0.1,"Box background Red (RGB)",DCoordsVDB["MainBar"].bgR,sliderWidth,1,px,py,bgRChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].bgG
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgGChangeHandler(v)
		DCoordsVDB["MainBar"].bgG = v;
		updateBoxBgColor();
	end
	createSlider("bgGChangeHandler",frame,0,1,0.1,"Box background Green (RGB)",DCoordsVDB["MainBar"].bgG,sliderWidth,1,px,py,bgGChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].bgB
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgBChangeHandler(v)
		DCoordsVDB["MainBar"].bgB = v;
		updateBoxBgColor();
	end
	createSlider("bgBChangeHandler",frame,0,1,0.1,"Box background Blue (RGB)",DCoordsVDB["MainBar"].bgB,sliderWidth,1,px,py,bgBChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["MainBar"].bgA
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function bgAChangeHandler(v)
		DCoordsVDB["MainBar"].bgA = v;
		updateBoxBgColor();
	end
	createSlider("bgAChangeHandler",frame,0,1,0.1,"Box background Alpha",DCoordsVDB["MainBar"].bgA,sliderWidth,1,px,py,bgAChangeHandler)
	py = py - 70;
	
	
	
	
	
	
	
	
	
	
	
	
	--DCoordsVDB["MainBar"].x
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function xChangeHandler(v)
		DCoordsVDB["MainBar"].x = v;
		mainBarSetFrameAlignment();
	end
	createSlider("xChangeHandler",frame,-1000,1000,1,"Coordinates bar X",DCoordsVDB["MainBar"].x,sliderWidth,0,px,py,xChangeHandler)
	py = py - 40;
	
	--DCoordsVDB["MainBar"].y
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function yChangeHandler(v)
		DCoordsVDB["MainBar"].y = v;
		mainBarSetFrameAlignment();
	end
	createSlider("yChangeHandler",frame,-1000,1000,1,"Coordinates bar Y",DCoordsVDB["MainBar"].y,sliderWidth,0,px,py,yChangeHandler)
	py = py - 40;
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #