--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMinimap()
	DCVGlobal["DCOptions"].Minimap = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	local frame = DCVGlobal["DCOptions"].Minimap; 
	frame.name = "Minimap";
	frame.parent = DCVGlobal["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Minimap");
	
	
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 200;
	local sliderWidth = 200;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	
	
	--DCoordsVDB["Minimap"].visible
	local function hideLocationClickHandler(ticked)
		DCoordsVDB["Minimap"].hideLocation = ticked;
		updateMinimap();
	end
	createCheckbox("MinimapHideLocation",frame,"Hide minimap location bar",DCoordsVDB["Minimap"].hideLocation,px,py,hideLocationClickHandler);
	py = py - inc;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateMinimap()

	if (DCoordsVDB["Minimap"].hideLocation)then
			MiniMapWorldMapButton:Hide()
			MinimapZoneTextButton:Hide();
			--MinimapBorder:Hide()
			MinimapBorderTop:Hide()
			--Minimap:SetMaskTexture("Interface\\BUTTONS\\WHITE8X8")
	else
			MiniMapWorldMapButton:Show()
			MinimapZoneTextButton:Show();
			--MinimapBorder:Show()
			MinimapBorderTop:Show()
			--Minimap:SetMaskTexture("Interface\\BUTTONS\\WHITE8X8")
	end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #