--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageObjectivesTracker()
	DCVGlobal["DCOptions"].Objectives = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	local frame = DCVGlobal["DCOptions"].Objectives; 
	frame.name = "Objectives tracker";
	frame.parent = DCVGlobal["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"Objectives tracker");
	
	
	
	-- Vars
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	local msg = "";
	
	
	
	
	--DCoordsVDB["Objectives"].enabled
	createCheckbox("cbObjectivesEnabled",frame,"Enable Objectives Tracker featuers",DCoordsVDB["Objectives"].enabled,px,py,cbDragObjectivesChangeHandler);
	py = py - 24;
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "NOTE: Disabling Objectives Tracker features will cause a UI RELOAD" .. "\n\n";
	local mainInfo1 = createLabel("mainInfo1",frame,msg,15,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 25;
	
	
	
	--DCoordsVDB["Objectives"].alpha
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function objectivesAlphaChangeHandler(v)
		sliderObjectivesAlphaChangeHandler(v);
	end
	createSlider("objectivesAlphaChangeHandler",frame,0,1,0.1,"Objectives Alpha",DCoordsVDB["Objectives"].alpha,sliderWidth,1,px,py,objectivesAlphaChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["Objectives"].scale
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function objectivesScaleChangeHandler(v)
		sliderObjectivesScaleChangeHandler(v);
	end
	createSlider("objectivesScaleChangeHandler",frame,0.1,1,0.01,"Objectives Scale",DCoordsVDB["Objectives"].scale,sliderWidth,2,px,py,objectivesScaleChangeHandler)
	py = py - 55;
	
	
	
	--DCoordsVDB["Objectives"].height
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function objectivesHeightChangeHandler(v)
		sliderObjectivesHeightChangeHandler(v);
	end
	createSlider("objectivesHeightChangeHandler",frame,100,900,0.1,"Objectives Height",DCoordsVDB["Objectives"].height,sliderWidth,1,px,py,objectivesHeightChangeHandler)
	py = py - 40;
	
	
	
	
	
	
	
	
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #